# Method: enterprises.devices.list

- [HTTP request](https://developers.google.com/nest/device-access/reference/rest/v1/enterprises.devices/list#body.HTTP_TEMPLATE)
- [Path parameters](https://developers.google.com/nest/device-access/reference/rest/v1/enterprises.devices/list#body.PATH_PARAMETERS)
- [Query parameters](https://developers.google.com/nest/device-access/reference/rest/v1/enterprises.devices/list#body.QUERY_PARAMETERS)
- [Request body](https://developers.google.com/nest/device-access/reference/rest/v1/enterprises.devices/list#body.request_body)
- [Response body](https://developers.google.com/nest/device-access/reference/rest/v1/enterprises.devices/list#body.response_body)
  - [JSON representation](https://developers.google.com/nest/device-access/reference/rest/v1/enterprises.devices/list#body.ListDevicesResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://developers.google.com/nest/device-access/reference/rest/v1/enterprises.devices/list#body.aspect)
- [Examples](https://developers.google.com/nest/device-access/reference/rest/v1/enterprises.devices/list#examples)

Lists devices managed by the enterprise.

### HTTP request

`GET https://smartdevicemanagement.googleapis.com/v1/{parent=enterprises/*}/devices`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `parent` | `string` The parent enterprise to list devices under. E.g. "enterprises/XYZ". |

### Query parameters

| Parameters ||
|---|---|
| `filter` | `string` Optional filter to list devices. Filters can be done on: Device custom name (substring match): 'customName=wing' |

### Request body

The request body must be empty.

### Response body

Response message for SmartDeviceManagementService.ListDevices

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "devices": [ { object (`https://developers.google.com/nest/device-access/reference/rest/v1/enterprises.devices#Device`) } ] } ``` |

| Fields ||
|---|---|
| `devices[]` | ``object (`https://developers.google.com/nest/device-access/reference/rest/v1/enterprises.devices#Device`)`` The list of devices. |

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/sdm.service`

For more information, see the [OAuth 2.0 Overview](https://developers.google.com/identity/protocols/OAuth2).